/**
 * 首页 - 系统切换 
 */

// 文件路径配置
var path = getUrl(location.href);// 获取项目 绝对路径
var curTablePath = '/components/popup_switch/';
var cssPath = path + curTablePath+ 'popup_switch.css';
// var htmlPath = path + curTablePath+ 'popup_switch.html';
/**
 * 引入单选组件CSS
 */
addCssLink(cssPath);
/**
 * 侧边栏 - 查询 主HTML片段
 */
var common_sidebar =
	"\
	<div class='popup-switch' id='popupSwitch' style='display:none'>\
		<div class='popup-mask' id='popupMask'></div>\
		<div class='popup-content' id='popupContent'>\
			<div class='popup-hd'>\
				<div>请选择</div>\
				<div>需要进入的系统</div>\
			</div>\
			<div class='popup-bd'>\
				<div class='sales-home' id='salesHome'>\
					<div class='flex-box align-items-center'>\
						<div class='cell-1'>\
							<span class='img-pop-presale'></span>\
						</div>\
						<div class='cell-2 text-right'>\
							<span>销售端首页</span>\
						</div>\
						<div class='cell-1 text-right'>\
							<span class='icon-arrow-r'></span>\
						</div>\
					</div>\
				</div>\
				<div class='service-home' id='serviceHome'>\
					<div class='flex-box align-items-center'>\
						<div class='cell-1'>\
							<span class='img-pop-aftersale'></span>\
						</div>\
						<div class='cell-2 text-right'>\
							<span>服务端首页</span>\
						</div>\
						<div class='cell-1 text-right'>\
							<span class='icon-arrow-r'></span>\
						</div>\
					</div>\
				</div>\
			</div>\
		</div>\
	</div>\
	"
// --------------------------------
	
// 插入侧边栏 - 查询 主HTML片段
document.write(common_sidebar);

// 需要操作的 DOM对象
var popupSwitchDom = null;  // 系统切换弹窗
var popupMaskDom = null;	 // 弹窗遮罩
var salesHomeDom = null;	 // 销售首页
var serviceHomeDom = null;  // 服务首页
// DOM结构加载完成后 执行
$(document).ready(function() {

	// 1.获取DOM
	popupSwitchDom = $('#popupSwitch')
	popupMaskDom = $('#popupMask')
	salesHomeDom = $('#salesHome')
	serviceHomeDom = $('#serviceHome')
	// 禁止点击穿透
	preventDefaultObj(popupMaskDom) 
	// 2.绑定事件
	popupMaskDom.on('tap',function(){
		hidePop();
	})
	salesHomeDom.on('tap',function(){
		openSalesHome();
	})
	serviceHomeDom.on('tap',function(){
		openServiceHome();
	})
	
})
// 打开销售主页
function openSalesHome(){
	var curPage = window.location.pathname
	console.log(1,'当前页面路径',curPage)
	// 判断当前页面 是否已处于销售主页
	if(curPage.indexOf('index')<0 ){
		ToUrl('index.html')
	}else{
		console.log(2,'已是销售主页')
	}
	hidePop()
}
// 打开服务主页
function openServiceHome(){
	var curPage = window.location.pathname
	console.log(2,'当前页面路径',curPage)
	// 判断当前页面 是否已处于服务主页
	if(curPage.indexOf('complaint')<0 ){
		ToUrl('complaint.html')
	}else{
		console.log(2,'已是服务主页')
	}
	hidePop()
}

// 隐藏弹窗
function hidePop() {
	// console.log('隐藏查询弹框')
	popupSwitchDom.hide();
	popupMaskDom.hide();
	// commonSidebar.css("left","100%");
	// openScroll();
}
/**
 * preventDefault 阻止冒泡 防止点击穿透
 * @param {Object}：select  绑定点击事件的元素 接受jq选择器对象
 */
function preventDefaultObj(select) {
	if(0 == select.length ) return;
	select.on("touchend", function(event) {
		event.preventDefault();
	})
}

/**
 * getUrl 获取项目绝对路径
 */
function getUrl(url){
	var n = url.lastIndexOf("\/");
	return url.substring(0,n); // 返回项目路径
}

// 禁止背景滚动
function noScroll(){
	$('html,body').addClass('no-scroll')
}
// 允许背景滚动
function openScroll(){
	$('html,body').removeClass('no-scroll')
}